diff -urN memcached-1.4.13/AUTHORS.repcached memcached-1.4.13-repcached-2.3.1/AUTHORS.repcached
--- memcached-1.4.13/AUTHORS.repcached	Thu Jan  1 03:00:00 1970
+++ memcached-1.4.13-repcached-2.3.1/AUTHORS.repcached	Mon Feb 13 05:07:52 2012
@@ -0,0 +1,2 @@
+YASUI Masanobu <yasui-m at klab.org>
+HIROSE Masaaki <hirose at klab.org>
diff -urN memcached-1.4.13/ChangeLog.repcached memcached-1.4.13-repcached-2.3.1/ChangeLog.repcached
--- memcached-1.4.13/ChangeLog.repcached	Thu Jan  1 03:00:00 1970
+++ memcached-1.4.13-repcached-2.3.1/ChangeLog.repcached	Mon Feb 13 05:07:52 2012
@@ -0,0 +1,63 @@
+2011-02-14  Maxim Dounin
+
+  * release of repcached-2.3.1 for memcached-1.4.5
+  * fixed another cpu hog on network problems
+
+2010-11-24  Maxim Dounin
+
+  * release of repcached-2.3 for memcached-1.4.5
+  * fixed cpu hog on transient network problems
+
+2009-05-26  YASUI Masanobu
+  * release of repcached-2.2 for memcached-1.2.8
+
+2009-01-05  YASUI Masanobu
+  * fixed segmentation fault on marugoto copying for 64bit platform
+
+2008-08-26  HIROSE Masaaki
+
+  * release of repcached-2.1 for memcached-1.2.6
+
+2008-04-11  YASUI Masanobu
+  * release of repcached-2.0 for memcached-1.2.5
+  * multi master replication support
+  * replication able to cas id
+  * fixed replication connect error
+
+2008-03-10  YASUI Masanobu
+  * release of repcached-1.2 for memcached-1.2.4
+  * bug fix.
+  * flags was not possible to replication.
+    always stored to zero in backup.
+      master> set key flags expire len
+      backup> set key 0     expire len
+    This bug was corrected.
+  * fixed memory leaks when replicating the flush_all command.
+
+2008-02-15  HIROSE Masaaki
+
+  * release of repcached-1.1 for memcached-1.2.4
+
+2008-02-05  YASUI Masanobu
+
+  * support memcached-1.2.4's new commands (append, prepend, cas)
+    known problem: repcached-1.1 cannot replicate cas unique id. so
+    it is possible that cas operation is fail if master/backup
+    fail-over occur between gets and cas.
+
+2008-02-04  HIROSE Masaaki
+
+  * include test suite for replication.
+    prove -l t.rep
+
+2007-11-13  HIROSE Masaaki
+
+  * release of repcached-1.0 for memcached-1.2.2
+
+  * first release.
+
+
+
+Local Variables:
+mode: change-log
+End:
diff -urN memcached-1.4.13/Makefile.am memcached-1.4.13-repcached-2.3.1/Makefile.am
--- memcached-1.4.13/Makefile.am	Fri Jan  6 22:19:50 2012
+++ memcached-1.4.13-repcached-2.3.1/Makefile.am	Mon Feb 13 01:13:58 2012
@@ -31,6 +31,10 @@
 memcached_SOURCES += sasl_defs.c
 endif
 
+if ENABLE_REPLICATION
+memcached_SOURCES += replication.h replication.c
+endif
+
 memcached_debug_SOURCES = $(memcached_SOURCES)
 memcached_CPPFLAGS = -DNDEBUG
 memcached_debug_LDADD = @PROFILER_LDFLAGS@
diff -urN memcached-1.4.13/assoc.c memcached-1.4.13-repcached-2.3.1/assoc.c
--- memcached-1.4.13/assoc.c	Fri Jan  6 22:19:50 2012
+++ memcached-1.4.13-repcached-2.3.1/assoc.c	Mon Feb 13 01:13:58 2012
@@ -270,3 +270,51 @@
 }
 
 
+#ifdef USE_REPLICATION
+char *assoc_key_snap(int *n)
+{
+    char *p = NULL;
+    char *b = NULL;
+    item *i = NULL;
+    int  co = 0;
+    int  sz = 1;
+    int  hs = 0;
+    int  hm = hashsize(hashpower);
+
+    hs = hm;
+    while(hs--){
+        if(expanding && hs < hashsize(hashpower - 1) && hs >= expand_bucket){
+            i = old_hashtable[hs];
+        }else{
+            i = primary_hashtable[hs];
+        }
+        while(i){
+            sz += i->nkey + 1;
+            co++;
+            i = i->h_next;
+        }
+    }
+
+    if(co){
+        if((p = b = malloc(sz))){
+            hs = hm;
+            while(hs--){
+                if(expanding && hs < hashsize(hashpower - 1) && hs >= expand_bucket){
+                    i = old_hashtable[hs];
+                }else{
+                    i = primary_hashtable[hs];
+                }
+                while(i){
+                    memcpy(p, ITEM_key(i), i->nkey);
+                    p += i->nkey;
+                    *(p++) = 0;
+                    i = i->h_next;
+                }
+            }
+            *(p++) = 0;
+        }
+    }
+    if(n) *n = co;
+    return(b);
+}
+#endif /* USE_REPLICATION */
diff -urN memcached-1.4.13/assoc.h memcached-1.4.13-repcached-2.3.1/assoc.h
--- memcached-1.4.13/assoc.h	Fri Jan  6 22:19:50 2012
+++ memcached-1.4.13-repcached-2.3.1/assoc.h	Mon Feb 13 01:13:58 2012
@@ -7,3 +7,6 @@
 int start_assoc_maintenance_thread(void);
 void stop_assoc_maintenance_thread(void);
 
+#ifdef USE_REPLICATION
+char *assoc_key_snap(int *n);
+#endif /*USE_REPLICATION*/
diff -urN memcached-1.4.13/config.h.in memcached-1.4.13-repcached-2.3.1/config.h.in
--- memcached-1.4.13/config.h.in	Fri Feb  3 01:24:25 2012
+++ memcached-1.4.13-repcached-2.3.1/config.h.in	Mon Feb 13 05:07:26 2012
@@ -117,6 +117,9 @@
 /* Define to 1 if you have the ANSI C header files. */
 #undef STDC_HEADERS
 
+/* Define this if you want to use replication */
+#undef USE_REPLICATION
+
 /* Version number of package */
 #undef VERSION
 
diff -urN memcached-1.4.13/configure.ac memcached-1.4.13-repcached-2.3.1/configure.ac
--- memcached-1.4.13/configure.ac	Thu Feb  2 10:01:29 2012
+++ memcached-1.4.13-repcached-2.3.1/configure.ac	Mon Feb 13 01:14:16 2012
@@ -441,6 +441,18 @@
   AC_MSG_ERROR([Can't enable threads without the POSIX thread library.])
 fi
 
+dnl Check whether the user wants replication or not
+AC_ARG_ENABLE(replication,
+  [AS_HELP_STRING([--enable-replication],[support replication])],
+  [if test "x$enable_threads" = "xyes"; then
+     AC_MSG_ERROR([Can't enable threads and replication together.])
+   else
+     AC_DEFINE([USE_REPLICATION],,[Define this if you want to use replication])
+   fi
+  ])
+
+AM_CONDITIONAL(ENABLE_REPLICATION, test "x$enable_replication" = "xyes")
+
 AC_CHECK_FUNCS(mlockall)
 AC_CHECK_FUNCS(getpagesizes)
 AC_CHECK_FUNCS(memcntl)
diff -urN memcached-1.4.13/items.c memcached-1.4.13-repcached-2.3.1/items.c
--- memcached-1.4.13/items.c	Thu Feb  2 06:02:02 2012
+++ memcached-1.4.13-repcached-2.3.1/items.c	Mon Feb 13 01:18:17 2012
@@ -141,6 +141,9 @@
             STATS_LOCK();
             stats.evictions++;
             STATS_UNLOCK();
+#ifdef USE_REPLICATION
+            replication_call_del(ITEM_key(search), search->nkey);
+#endif /* USE_REPLICATION */
             it = search;
             slabs_adjust_mem_requested(it->slabs_clsid, ITEM_ntotal(it), ntotal);
             do_item_unlink_nolock(it, hash(ITEM_key(it), it->nkey, 0));
@@ -283,8 +286,14 @@
     stats.total_items += 1;
     STATS_UNLOCK();
 
+#ifdef USE_REPLICATION
+    /* Allocate a new CAS ID on link. */
+    if(!(it->it_flags & ITEM_REPDATA))
+        ITEM_set_cas(it, (settings.use_cas) ? get_cas_id() : 0);
+#else
     /* Allocate a new CAS ID on link. */
     ITEM_set_cas(it, (settings.use_cas) ? get_cas_id() : 0);
+#endif /* USE_REPLICATION */
     assoc_insert(it, hv);
     item_link_q(it);
     refcount_incr(&it->refcount);
